#include <stdlib.h>
#include <assert.h>
#include "mat.h"

template <> void Mat<float>::rand( float const & lo, float const & hi )
{
  int const tot( m_size[0] * m_size[1] );
  
  for( int i = 0; tot != i; ++i )
  {
    float const r( lo + ( hi - lo ) * float( random() % 1000 ) / 1000.0f);
    m_mat[i] = r;
  }
}

template<>
float minus( float const & a, float const & b )
{
  return a - b;
}

template <>
float Zero<float>()
{
  return 0.0f;
}

template <>
float One<float>()
{
  return 1.0f;
}

template<typename T>
void Mat<T>::initStep()
{
  float stepf( 1.0f / ( float( size()[0] * size()[1] + 1 ) ) );

  for( int i = 0; i != ( size()[0] * size()[1] ); ++i )
    m_mat[i] = float( i + 1 ) * stepf;
}


template class Mat<float>;
