template <typename T>
Mat<T> const & Mat<T>::operator*=( T const & d )
{
  for( uint i = 0, togo( m_size[0] * m_size[1] ); togo != i; ++i )
    m_mat[i] *= d;

  return *this;
}

template <typename T>
Mat<T> const Mat<T>::t() const
{
  Mat<T> rv;
  rv.size( m_size[1], m_size[0] );

  for( int i = 0; m_size[0] != i; ++i )
    for( int j = 0; m_size[1] != j; ++j )
      rv[j][i] = (*this)[i][j];

  return rv;
}

template <typename T>
Mat<T> &Mat<T>::f( T f( T const &, T const & ), Mat<T> const &a )
{
  assert( a.m_size[0] == m_size[0] );
  assert( a.m_size[1] == m_size[1] );

  int const togo( m_size[0] * m_size[1] );
  for( int c = 0; togo != c; ++c )
    m_mat[c] = f( m_mat[c], a.m_mat[c] );

  return *this;
}

template <typename T>
T minus( T const &, T const & );

template <typename T>
Mat<T> &Mat<T>::operator-=( Mat<T> const & a ) 
{
  return this->f( minus, a );
}

template <typename T>
Mat<T> const Mat<T>::operator-( Mat<T> const & a ) const
{
  Mat<T> rv( *this );

  return rv -= a;
}


#if 0
template <typename T>
Mat<T> const Mat<T>::operator*( Mat<T> const & a ) const
{
  Mat<T> rv = Zeros( size()[0], a.size()[1] );

  assert( size()[1] == a.size()[0] );
  for( uint colRes = 0; rv.size()[1] != colRes; ++colRes )
    for( uint rowRes = 0; rv.size()[0] != rowRes; ++rowRes )
      for( uint intCount = 0; a.size()[0] != intCount; ++intCount )
	rv[rowRes][colRes] += (*this)[rowRes][intCount] * a[intCount][colRes];

  return rv;
}
#endif

template <typename T>
T One();

template <typename T>
T Zero();




template <typename T>
Mat<T> Mat<T>::Fixed( uint r, uint c, T f() )
{
  Mat<T> rv;
  rv.size( r, c );
  
  for( uint i = 0, togo( r * c ); i != togo; ++i )
    rv.m_mat[i] = f();
  return rv;
}

template <typename T>
Mat<T> Mat<T>::Ones( uint const *size )
{
  return Fixed( size[0], size[1], One );
}

template <typename T>
Mat<T> Mat<T>::Zeros( uint r, uint c )
{
  Mat<T> rv( Fixed( r, c, Zero) );
  return rv;
}

template <typename T>
Mat<T> Mat<T>::I( uint r, uint c )
{
  Mat<T> rv;
  rv.size( r, c );
  
  for( int i = 0; r != i; ++i )
    for( int j = 0; c != j; ++j )
      rv[i][j] = ( i == j ? One<T>(): Zero<T>() );

  return rv;
}

