#include <iostream>
#include "mat.h"
#include "NN.h"


template <typename T> 
std::basic_ostream<char> &
operator<<( std::basic_ostream<char> &o, Mat<T> const & m )
{
  for( int i = 0; m.m_size[0] != i; ++i )
  {
    o << ( i ? "   " : "[  ");

    for( int j = 0; m.m_size[1] != j; ++j )
    {
      o << m(i, j);
      if( ( m.m_size[1] - 1 ) != j )
	o << ", ";
    }
	
    o << ( ( ( m.m_size[0] - 1 ) == i ) ? "  ]" : ";" );
    o << std::endl;
  }
}

template <typename T>
void NeuralNet<T>::dump()
{
  std::cout << "entries : " << std::endl;
  std::cout << m_ys[0];
  std::cout << std::endl;

  
  for( int i = 0; m_nLayers - 1 != i; ++i )
  {
    std::cout << "layer : " << i << std::endl;
    std::cout << "w" << std::endl;
    std::cout << m_weights[i];
    std::cout << std::endl;

    std::cout << "v" << std::endl;
    std::cout << m_vs[i + 1];
    std::cout << std::endl;

    std::cout << "y" << std::endl;
    std::cout << m_ys[i + 1];
    std::cout << std::endl;

    std::cout << std::endl;    
  }
}

template class NeuralNet<float>;
