#include <iostream>
#include <vec.h>
#include <math.h>// for sqrt

/*
** Hi jp I hope it is not too late for your code test submission
** I used my little vector headers file and the book in 
** Real-Time Collision Detection By Christer Ericson
*/


struct Vector4
{
  float x,y,z,w;
};
struct Capsule 
{  
  Vector4 start, end;
  float radius;
};

typedef Vertex<float> Vertexf;

//todo: factorisr with distanceLine2 / closest point 2 ?
template <typename t>
t distanceSegm2( Vertex<t> l1orig, Vertex<t> l1end, Vertex<t> l2orig, Vertex<t> l2end )
{

  // fixme: sqrt hidden here
  Vertexf const l1dir( ( l1end - l1orig ).unit() );
  Vertexf const l2dir( ( l2end - l2orig ).unit() );

  Vertexf const w0( l1orig - l2orig );

  // ? I am going by the book here
  t const a( l1dir * l1dir );
  t const b( l1dir * l2dir );
  t const c( l2dir * l2dir );
  t const d( l1dir * w0 );
  t const e( l2dir * w0 );

  t const denom( a * c - b * b );

  //  if( Zero<t>() == t )
  Vertex<t> point1, point2;

  /*
  ** the book is incoherent here also I clamp the result so I get only
  ** things on the segment. fixme: I am doing more sqrt, that can be
  ** avoided by modifying the algo, or just put together with the dist
  ** earlier in the function
  */

  t const l2length( ( l2end - l2orig ).length() );
  if( .0f == denom ) // fixme template spec
  {
    point1 = l1orig;
    point2 = l2orig + l2dir * clamp( 0.0f, l2length, e / c );
  } else
  {
    t const l1length( ( l1end - l1orig ).length() );
    point1 = l1orig + l1dir * clamp( 0.0f, l1length,
				     ( b * e - c * d ) / denom );
    point2 = l2orig + l2dir * clamp( 0.0f, l2length,
				     ( a * e - b * d ) / denom );
  }

  
  return point1.dist2( point2 );
}

template <typename t> inline t sqr( t const & x ) { return x * x; }

// fixme: lots of branching
template <typename t> 
inline t
clamp( t const & low, t const & hi,t const & x )
{
  if( x > low )
  {
    if( x < hi )
      return x;
    else
      return hi;
  } else
    return low;
}

bool
CapsuleCollisionTest( Capsule const &c1, Capsule const &c2 )
{
  float minDist( c1.radius + c1.radius );

  /*
  ** I convert to my own data type, because i need the dot operation
  ** and things like that
  */
  Vertexf const c1start( c1.start.x, c1.start.y, c1.start.z );
  Vertexf const c1end( c1.end.x, c1.end.y, c1.end.z );
  Vertexf const c2start( c2.start.x, c2.start.y, c2.start.z );
  Vertexf const c2end( c2.end.x, c2.end.y, c2.end.z );



  return distanceSegm2( c1start, c1end, c2start, c2end ) < sqr( minDist );
}

int 
main( int argc, char *argv[] )
{
  Capsule c1 = 
    {
      { 0, 0, 0, 1},
      { 1, 0, 0, 1},
      1
    };
   Capsule c2 = 
    {
      { .5, 0, 1.9, 1},
      { .5, 0, 3, 1},
      1
    };

   std::cout << CapsuleCollisionTest( c1, c2 ) << std::endl;
  
}
